【DP|01背包】HDU-2955 Robberies

69 篇文章 0 订阅
13 篇文章 0 订阅

Robberies

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)

Problem Description
The aspiring Roy the Robber has seen a lot of American movies, and knows that the bad guys usually gets caught in the end, often because they become too greedy. He has decided to work in the lucrative business of bank robbery only for a short while, before retiring to a comfortable job at a university.


For a few months now, Roy has been assessing the security of various banks and the amount of cash they hold. He wants to make a calculated risk, and grab as much money as possible.


His mother, Ola, has decided upon a tolerable probability of getting caught. She feels that he is safe enough if the banks he robs together give a probability less than this.
 

Input
The first line of input gives T, the number of cases. For each scenario, the first line of input gives a floating point number P, the probability Roy needs to be below, and an integer N, the number of banks he has plans for. Then follow N lines, where line j gives an integer Mj and a floating point number Pj . 
Bank j contains Mj millions, and the probability of getting caught from robbing it is Pj .
 

Output
For each test case, output a line with the maximum number of millions he can expect to get while the probability of getting caught is less than the limit set.

Notes and Constraints
0 < T <= 100
0.0 <= P <= 1.0
0 < N <= 100
0 < Mj <= 100
0.0 <= Pj <= 1.0
A bank goes bankrupt if it is robbed, and you may assume that all probabilities are independent as the police have very low funds.
 

Sample Input
  
  
3 0.04 3 1 0.02 2 0.03 3 0.05 0.06 3 2 0.03 2 0.03 3 0.05 0.10 3 1 0.03 2 0.02 3 0.05
 

Sample Output
  
  
2 4 6
 
————————————————————————————————————————————————————————
题意:给出几家银行拥有的钱数、抢走该银行的所有钱被抓的概率和能够容忍的最大被抓概率,求在被抓概率在容忍线以下时能够抢劫的最大钱数。
思路:还是很容易看出来是背包问题的,但是一开始我以为要把抢到的钱数当做价值,能够容忍的逃跑概率当做背包容量。我还很困惑浮点数精度问题,要放大多少倍之类的。
这不是傻缺吗?概率当做容量岂不是要直接相加?这概率明明是相乘的。
银行只有那么几家,全抢走的钱数是一定的,我们把它当做背包的容量。
然后将抢走若干钱之后逃跑的概率相乘,显然抢得越多逃跑的可能性越小,符合题意。
最后从最大钱数向下找到容忍线,输出此时背包消耗的体积。
看来要是真正能够的理解了背包问题,对于“容量”和“价值”,以及整个DP的过程要清晰地掌握。
代码如下:
/**
 * ID: j.sure.1
 * PROG:
 * LANG: C++
 */
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <algorithm>
#include <ctime>
#include <cmath>
#include <stack>
#include <queue>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <climits>
#include <iostream>
#define Mem(f, x) memset(f, x, sizeof(f))
#define Pb push_back
#define LL long long
using namespace std;
const int INF = 0x3f3f3f3f;
const double eps = 1e-8;
/****************************************/
const int N = 10005;;
int V, n, m[N];
double dp[N], p[N];

int main()
{
#ifdef J_Sure
    freopen("000.in", "r", stdin);
    //freopen("999.out", "w", stdout);
#endif
    int T;
    scanf("%d", &T);
    while(T--) {
        double lim;
        scanf("%lf%d", &lim, &n);
        lim = 1 - lim;
        V = 0;
        for(int i = 0; i < n; i++) {
            scanf("%d%lf", &m[i], &p[i]);
            p[i] = 1 - p[i];
            V += m[i];
        }
        Mem(dp, 0);
        dp[0] = 1;
        for(int i = 0; i < n; i++) {
            for(int j = V; j >= m[i]; j--) {
                dp[j] = max(dp[j], dp[j-m[i]] * p[i]);
            }
        }
        for(int j = V; j >= 0; j--) {
            if(dp[j] - lim >= eps) {
                printf("%d\n", j);
                break;
            }
        }
    }
    return 0;
}


  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值